/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package views;

import javax.swing.JOptionPane;
import controllers.AutorController;
/**
 *
 * @author jaimearroyo
 */
public class AutorEditNew extends javax.swing.JFrame {
    AutorController autor = new AutorController();
    /**
     * Creates new form CategoryNewEdit
     */
    public AutorEditNew() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        header_category = new javax.swing.JLabel();
        label_name_cat = new javax.swing.JLabel();
        txt_nombre = new javax.swing.JTextField();
        boton_guardar = new javax.swing.JButton();
        boton_listado = new javax.swing.JButton();
        label_accion = new javax.swing.JLabel();
        label_name_cat1 = new javax.swing.JLabel();
        txt_apellido_paterno = new javax.swing.JTextField();
        label_name_cat2 = new javax.swing.JLabel();
        txt_apellido_materno = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        header_category.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        header_category.setText("Autores");

        label_name_cat.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat.setText("Nombre");

        txt_nombre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_nombreActionPerformed(evt);
            }
        });

        boton_guardar.setText("Guardar");
        boton_guardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boton_guardarActionPerformed(evt);
            }
        });

        boton_listado.setText("Listado de autores");
        boton_listado.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boton_listadoActionPerformed(evt);
            }
        });

        label_accion.setText("Ingresar nuevo autor");
        label_accion.setToolTipText("");

        label_name_cat1.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat1.setText("Apellido Paterno");

        txt_apellido_paterno.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_apellido_paternoActionPerformed(evt);
            }
        });

        label_name_cat2.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat2.setText("Apellido Materno");

        txt_apellido_materno.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_apellido_maternoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(34, 34, 34)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(label_name_cat1)
                            .addComponent(label_name_cat)
                            .addComponent(label_name_cat2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(txt_apellido_paterno)
                            .addComponent(txt_nombre)
                            .addComponent(txt_apellido_materno, javax.swing.GroupLayout.DEFAULT_SIZE, 214, Short.MAX_VALUE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(133, 133, 133)
                        .addComponent(label_accion))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(158, 158, 158)
                        .addComponent(header_category))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(106, 106, 106)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(boton_listado, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(boton_guardar, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(28, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(header_category)
                .addGap(17, 17, 17)
                .addComponent(label_accion, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat)
                    .addComponent(txt_nombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat1)
                    .addComponent(txt_apellido_paterno, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat2)
                    .addComponent(txt_apellido_materno, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 19, Short.MAX_VALUE)
                .addComponent(boton_guardar, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(boton_listado, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void txt_nombreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_nombreActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt_nombreActionPerformed
/**
 * Captura acción click del boton guardar, toma los valores de los campos se los pasa al controlador
 * @param evt evento click en el botón
 */
    private void boton_guardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boton_guardarActionPerformed

            if(!txt_nombre.getText().equals("") && !txt_apellido_paterno.getText().equals("") && !txt_apellido_materno.getText().equals("")){

                    autor.newone(txt_nombre.getText(), txt_apellido_paterno.getText(), txt_apellido_materno.getText());

                    if(autor.save() != -1){
                        JOptionPane.showMessageDialog(null, "Registro guardado/actualziado correctamente");
                        this.ir_a_listado();
                    }else{
                        JOptionPane.showMessageDialog(null, "Error al insertar/actualizar, vuelva a intentar");
                    }

            }else{
                JOptionPane.showMessageDialog(null, "Debes llenar todos los campos");
            }

    }//GEN-LAST:event_boton_guardarActionPerformed
/**
 * Evento click en el boton volver al listado, ejecuta el metodo ir_a_listado de la clase
 * @param evt evento click del boton
 */
    private void boton_listadoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boton_listadoActionPerformed
        this.ir_a_listado();
    }//GEN-LAST:event_boton_listadoActionPerformed

    private void txt_apellido_paternoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_apellido_paternoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt_apellido_paternoActionPerformed

    private void txt_apellido_maternoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_apellido_maternoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt_apellido_maternoActionPerformed

    /**
     * Genera una vista de listado, oculta la actual y muesta la vista del listado generada
     */
    public void ir_a_listado(){
        AutorIndex index_autor =new AutorIndex();
        this.setVisible(false);
        index_autor.setVisible(true);
    }
    
    /**
     * Tiene como parametro una instancia de AutorController con lo que a la vista actual se le 
     * setean los valores del formulario y se modifican unas etiquetas, esto
     * se ejecuta solo cuando se esta editando
     * @param autor_controller instancia de AutorController 
     */
    public void set_autor_controller(AutorController autor_controller){
        this.autor = autor_controller;
        Object[] autor_obj = autor_controller.get_fields();
        txt_nombre.setText(autor_obj[1].toString());
        txt_apellido_paterno.setText(autor_obj[2].toString());
        txt_apellido_materno.setText(autor_obj[3].toString());
        boton_guardar.setText("Actualizar");
        label_accion.setText("Editando autor id: "+autor_obj[0].toString());
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(AutorEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(AutorEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(AutorEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(AutorEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AutorEditNew().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton boton_guardar;
    private javax.swing.JButton boton_listado;
    private javax.swing.JLabel header_category;
    private javax.swing.JLabel label_accion;
    private javax.swing.JLabel label_name_cat;
    private javax.swing.JLabel label_name_cat1;
    private javax.swing.JLabel label_name_cat2;
    private javax.swing.JTextField txt_apellido_materno;
    private javax.swing.JTextField txt_apellido_paterno;
    private javax.swing.JTextField txt_nombre;
    // End of variables declaration//GEN-END:variables
}
